
Redmine - Defect #16482

Wrong search query for timelog, when timezone not UTC

2014-03-31 23:38 - Alexander Maslov

Status: New Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Time tracking Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version: 2.5.1

Description

How to reproduce:

0. You are need to have server/devbox timezone set to UTC+X, where X is positive.

1. At 00:30 I'm create a timelog entry.

2. Right after this at a timelog reports page I'm select option to show only today timelog entries.

3. After pressing the search button, I'm can't see the timelog entry.

4. After the X time after 00:00, I'm can press the search button and can see the timelog entry as it need to be.

How to fix:

1. Replace all Date.today to Time.zone.today.

Patch: WIP, writing tests, investigating side effects.

Related issues:

Related to Redmine - Patch #22320: Respect user's timezone when comparing / p... Closed

Related to Redmine - Defect #19033: Filters that utilize date/time ignore use... Closed

Related to Redmine - Defect #23189: Spent time by filter, offset by one day New

Related to Redmine - Feature #23630: Migrate to Rails 5.2 Closed

Has duplicate Redmine - Defect #25822: 'Spent time' report is timezone-depend... Closed

Has duplicate Redmine - Defect #26156: Spent time not working correctly with ... Closed

History

#1 - 2014-10-01 00:55 - Scott Macpherson

I think I'm seeing the same issue manifesting itself in a slightly different way. The timezone on my Redmine server is set to UTC, and I've set

config.active_record.default_timezone to :utc in config/enviroment.rb.

When I log work for local date 2014-10-01, but at a time when the UTC date is still 2014-09-30, attempting to view spent time where date is "today"

doesn't return any results. Entering today's date rather than just "today" does return the correct records though.

#2 - 2016-03-26 09:27 - Jens Krämer

patch in #22320

#3 - 2016-04-08 15:28 - Jan from Planio www.plan.io

- Related to Patch #22320: Respect user's timezone when comparing / parsing Dates added

#4 - 2016-04-08 15:28 - Jan from Planio www.plan.io

- Target version set to Candidate for next minor release

#5 - 2016-04-14 07:37 - Toshi MARUYAMA

- Related to Defect #19033: Filters that utilize date/time ignore user's UTC offset added

#6 - 2016-06-08 06:20 - Toshi MARUYAMA

- Status changed from New to Needs feedback

- Target version deleted (Candidate for next minor release)
I think this issue is fixed by #22320, right?

#7 - 2017-02-21 21:58 - Jamila Khan

I'm afraid not.

We just upgraded to 3.3.2.stable from 3.1.2.stable and this issue just showed up.

This is still a problem.

Our server is set to GMT-5, and all date based queries done by users whose local time zone is set to GMT-6 through GMT-11 give incorrect days.

We have two workers in GMT-8 whose date based queries are not working.

Queries for tickets due "today" show tomorrow.

Changing the time zone to GMT-5 makes the issue disappear.

Environment:

Redmine version                3.3.2.stable

Ruby version                   2.2.5-p319 (2016-04-26) [x86_64-linux]

Rails version                  4.2.7.1

Environment                    production

Database adapter               Mysql2

Please let me know if there are tests I can do that would help pinpoint the cause.

thanks,

#8 - 2017-02-21 22:10 - Jamila Khan

- File Screen Shot 2017-02-21 at 4.05.14 PM.jpg added

Example:

Server time zone GMT-5

User time zone set to GMT-8

Screenshot attached of query looking for tickets due 2/21/17, query returns tickets due 2/22/17.

#9 - 2017-03-22 04:55 - Toshi MARUYAMA

- Status changed from Needs feedback to New

#10 - 2017-04-07 18:26 - Jamila Khan

Thank you for marking this as New, is there any other information that I can help provide for those who are able to fix this?

Does anyone know of a patch that I could apply in the meantime?

thanks,

#11 - 2017-04-14 05:34 - Toshi MARUYAMA

- Related to Defect #23189: Spent time by filter, offset by one day added

#12 - 2017-04-24 20:23 - Jamila Khan

We just upgraded to 3.3.3.stable from 3.3.2.stable and this issue persists.

#13 - 2017-04-24 22:50 - Marius BĂLTEANU

It seems to be a Rails bug:

https://github.com/rails/rails/issues/3145

https://github.com/rails/rails/issues/6816

I looked in the Redmine code and everything looks fine for me until this line: source:trunk/app/models/query.rb#L1295 which returns for the date Mon,

20 Feb 2017 23:59:59 AKST -09:00 the value 2017-02-21 08:59:59.999999. I used "(GMT-09:00) Alaska" for user timezone and GMT-5 on the server

to reproduce the issue.

From what I understand, the issue is fixed on Rails 5.

#14 - 2017-05-08 18:24 - Jamila Khan

Thank you!

It looks like Redmine doesn't support Rails 5 yet.

#23630

#15 - 2017-05-30 18:47 - Jamila Khan

Is there any way to fix this other than upgrading to Rails 5, which doesn't seem possible yet?

2025-05-01 2/3

https://www.redmine.org/issues/22320
https://github.com/rails/rails/issues/3145
https://github.com/rails/rails/issues/6816
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/app/models/query.rb#L1295
https://www.redmine.org/issues/23630


#16 - 2017-05-30 18:51 - Toshi MARUYAMA

- Related to Feature #23630: Migrate to Rails 5.2 added

#17 - 2017-06-10 14:02 - Toshi MARUYAMA

- Has duplicate Defect #25822: 'Spent time' report is timezone-dependent (which it should not) added

#18 - 2017-06-12 17:49 - Jamila Khan

Thank you for relating this to the appropriate tickets.

That said, this is affecting the ability of our remote workers to effectively use redmine.

Does is appear there is anything we, as non-coders, could do other than wait for Redmine to support Rails 5?

It looks like #23630 is blocked by #19755 which looks pretty far down in the roadmap queue.

#19 - 2017-06-13 18:50 - Toshi MARUYAMA

- Has duplicate Defect #26156: Spent time not working correctly with user's zone different from system's time zone added

#20 - 2017-06-13 18:56 - Martin Jungowski

Thank you Toshi for linking my ticket with this one. Despite searching for quite I while I somehonw failed to find this.

Anyway, I'm having the exact same problem. In addition to time zone it also seems to be affected by language selected in "My account"...

#21 - 2017-11-10 07:35 - Tyrone Hattingh

Hi there,

I just upgraded from 2.3.3 --> 3.4.3 (rails 4.2) -> latest version (rails 5.1) and this issue is still occurring, it does not appear to be an issue with Rails

then. Any suggestions?

#22 - 2017-12-18 19:34 - Jamila Khan

This is still affecting the ability of our remote workers to effectively use redmine.

Thank you to those who have tested newer versions of rails.

To devs: is there more information that you would need from any of us in order to track down the cause of the bug?

#23 - 2022-03-25 21:23 - Andrew Perry

This is still happening on 4.1.6

It is particularly annoying when you try to generate a list of entries for 'this month' or 'between' dates when in the Western Hemisphere, for a team

working in the Eastern Hemisphere. You end up with entries displaying a date that is one day after the date range you selected so you have to

manually adjust the 'between' dates accordingly.

The problem is compounded when you have contractors working across far east and far west and a few spots in between. When you want to pay

them based on their hours, you have to be careful to avoid either missing a day or paying for the same day twice (especially if you are in a different

timezone at the time of generating the report!).

It would be great to display the applicable timezone being used for the report on this page, and IDEAL if you could choose to change it (or otherwise

work around it by changing your own timezone in your profile).

Is there any point updating here or should it be on the NEW #23189? Since that is 5 years old and included a patch that hasn't been applied, I am not

sure that would make a difference...

Thanks for an overall great Free product - other than reporting the issue and providing patches, how can we help resolve this?
